// --- [ global.h ] -----------------------------------------------------------
//
// tab = 3
// ----------------------------------------------------------------------------

#ifndef EXTERN
#define EXTERN extern
#endif

#define 	VNC_BUFFER_SIZE  		(256 * 3)			// Gre des Empfangspuffers
#define  VNC_BLOCK_SIZE			256 * 2     		// Blockgre beim Schreiben von Daten

#define  LED						PB0
#define  LED_PORT					PORTB
#define  LED_DDR					DDRB
#define  LED_ON					LED_PORT &= ~(1<<LED)
#define  LED_OFF					LED_PORT |=  (1<<LED)
#define  LED_TOG					LED_PORT ^=  (1<<LED)

#define  KEY_PIN					PIND
//#define  KEY_DDR					DDRD
#define  KEY_PORT					PORTD
#define	KEY_START				PD2
#define  KEY_CHANGE_ADR			PD3
#define	KEY_CHANGE_ADR_PRESSED (!(KEY_PIN & (1<<KEY_CHANGE_ADR)))
#define	KEY_START_PRESSED		(!(KEY_PIN & (1<<KEY_START)))
#define  KEY_START_RELEASED	(KEY_PIN & (1<<KEY_START))

#define  TRUE						1
#define	FALSE						0

#define  VNC_CLOSE				0
#define  VNC_CONTINUE			1

void error_msg(uint8_t);								// wird zum Anzeigen von Fehlern angefahren
void close_file(uint8_t);

// --- globale Variablen ------------------------------------------------------

EXTERN volatile uint8_t VNC_timeout;				// Zhler fr Warteschleifen (33 ms Takt)
EXTERN volatile uint8_t LED_timeout;				// Zhler fr blinkende LED  (33 ms Takt)
EXTERN volatile uint16_t vnc_head;					// Pointer auf vnc_buffer
EXTERN volatile uint16_t vnc_tail;
EXTERN volatile uint16_t vnc_bytes_in_buffer;	// zhlt die zwischengespeicherten Bytes
EXTERN uint8_t  vnc_buffer[VNC_BUFFER_SIZE];		// Empfangs- und ggf. Sendepuffer

EXTERN uint8_t spi_in;									// globale Variable zum Empfang von Daten via SPI
EXTERN char msg[11];										// zur Umwandlung von Zahlen in Ziffernfolgen

EXTERN volatile uint8_t time[6];						// Datum und Uhrzeit fr Dateieintrge
EXTERN union filesize {uint32_t dword[1]; uint8_t byte[4];} VNC_fs; // globale Variable fr Filesize
EXTERN union transmit {uint32_t dword[1]; uint8_t byte[4];} VNC_tx; // globale Variable fr bertragen Datenmenge
EXTERN uint8_t VNC_error;

// --- [ eof ] ----------------------------------------------------------------
